Ruby trunk - Bug #1720

[NaN] == [NaN] 0 true 000
07/03/2009 09:43 PM - tadf (tadayoshi funaba)

Status: Closed

Priority: Normal

Assignee: mrkn (Kenta Murata)

Target version: 2.0.0

ruby -v: ruby 1.9.2dev (2009-07-03 trunk 23945) |Backport: 2.3: UNKNOWN, 2.4: UNKNOWN
[i1686-linux]

Description

=begin

NaN = 0.0/0

[NaN] == [NaN] [ true 0000000

NaN == NaN #=> false
[1] ==[1.0] #=> true

00000o00ooboonoobonDoo

=end

Related issues:
Has duplicate Ruby trunk - Bug #7676: Comparison of Float::NAN in array behav... Open

Associated revisions

Revision 6ea34efa - 11/08/2012 12:34 AM - mrkn (Kenta Murata)

e numeric.c: Add description of that the results of the comparing operations of two NaNs are undefined. [#1720] [ruby-dev:38725]
[ruby-core:36966]

git-svn-id: svn+ssh:/ci.ruby-lang.org/ruby/trunk@37546 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 37546 - 11/08/2012 12:34 AM - mrkn (Kenta Murata)

e numeric.c: Add description of that the results of the comparing operations of two NaNs are undefined. [#1720] [ruby-dev:38725]
[ruby-core:36966]

Revision 37546 - 11/08/2012 12:34 AM - mrkn (Kenta Murata)

e numeric.c: Add description of that the results of the comparing operations of two NaNs are undefined. [#1720] [ruby-dev:38725]
[ruby-core:36966]

Revision 37546 - 11/08/2012 12:34 AM - mrkn (Kenta Murata)

e numeric.c: Add description of that the results of the comparing operations of two NaNs are undefined. [#1720] [ruby-dev:38725]
[ruby-core:36966]

Revision 37546 - 11/08/2012 12:34 AM - mrkn (Kenta Murata)

e numeric.c: Add description of that the results of the comparing operations of two NaNs are undefined. [#1720] [ruby-dev:38725]
[ruby-core:36966]

Revision 37546 - 11/08/2012 12:34 AM - mrkn (Kenta Murata)

e numeric.c: Add description of that the results of the comparing operations of two NaNs are undefined. [#1720] [ruby-dev:38725]
[ruby-core:36966]

Revision 37546 - 11/08/2012 12:34 AM - mrkn (Kenta Murata)

e numeric.c: Add description of that the results of the comparing operations of two NaNs are undefined. [#1720] [ruby-dev:38725]
[ruby-core:36966]

History

#1 - 07/05/2009 01:14 AM - matz (Yukihiro Matsumoto)
0000 0ooooo

In message "Re: [ruby-dev:38725] [Bug #1720] [NaN] == [NaN] 0 true 000"
on Fri, 3 Jul 2009 21:43:24 +0900, tadayoshi funaba redmine@ruby-lang.org writes:

NaN = 0.0/0

[NaN] == [NaN] [ true 0000000
NaN == NaN #=> false

[1] == [1.0] #=> true

0000oDoDoDoDoonoDoDoDng

0000rb_equal()00000000000000000000D
DDDDDDDDDDDDDDDDDDDDDNaNDDDDDD
equal?000000==00000000000000000000
DDDDDDDDDDDDDDDDD

00000000000000000000o0nDonDnanD
0oooboooooo

#2 - 07/05/2009 01:31 AM - matz (Yukihiro Matsumoto)
0000 0ooooo

In message "Re: [ruby-dev:38734] Re: [Bug #1720] [NaN] == [NaN] [ true 000"
on Sun, 5 Jul 2009 01:14:16 +0900, Yukihiro Matsumoto matz@ruby-lang.org writes:

NaN = 0.0/0
[NaN] == [NaN] [ true 0000000

NaN == NaN #=> false
[1] == [1.0] #=> true

Qo0oooboooooooooDooooO

0000rb_equal()000000000000000000000
000000O0O0Oo0n0D0D0000NaNODO00O
equal?000000-=00000000000000000000
DDDDDDDDDDDDDDDDD

aooooooa

(1) NaN == NaN [ true 000
DDDDDDD NaN 0000000000

2) rb_equal()00equal?0000000000
DDDDDDDDDDDDD
(3) rb_equal()IT_FLOATOOONN
2DDDDDDDDDDDDDDDDDDD
ao0noooonoooon
(4) 000000000DOOODDOOO

goobooooo

000000000000000000D00ononanang
0000o0oDoooonenononoo

#3 - 07/05/2009 06:35 PM - tadf (tadayoshi funaba)

00000000o0ooonooo
0000000000000000n0noDono0aD
00000000000 ODODOD

#4 - 07/13/2009 08:53 PM - yugui (Yuki Sonoda)
- Status changed from Open to Assigned
- Assignee set to matz (Yukihiro Matsumoto)

- Priority changed from Normal to 3

00000000
NaN00000000000000000000000o000o00a00oo0nanno0noonna0noo0na0na0nDO0na0nE00Da0Da0DDO0Da0DE00DO00a0DD0000@ DO0DE0D

#5 - 07/13/2009 09:14 PM - keiju (Keiju Ishitsuka)
ooonopoooon.

In [ruby-dev:38735] the message: "[ruby-dev:38735] Re: [Bug #1720]
[NaN] == [NaN] [ true 000", on Jul/05 01:31(JST) Yukihiro
Matsumoto writes:

Qooo aooooo

(1) NaN == NaN [ true 000

(0000000 NaN DDDDODDDDD

(2) rb_equal()l00equal?0000000000
aoooooonoooon

(3) rb_equal()IT_FLOATOOOOD
2[1000000000000000000
aoooooonooooon

(4) 00000000000DDOOO00

00000000000000000000000a00000n
000000opoonoDenonoooo

aooa, (nobooooooo.
0ood, (mooo:
(1)

nanl = 0.0/0

nan2 = 0.0/0

(o,

nanl == nanl => true
nanl == nan2 => false
aooa,

nanl.equal? (nanl)

(o,

nanl == nanl => false

00000,00000000000000000000000000. nant
Unant1000000000000000O0O0.

0000000 Nan ODODODODOD

DDDDDD, 0000000 nan1 == nan2 => false 000000000
aooao.

>> 00 00 <<

>> e-mail: keiju@ishitsuka.com <<---

#6 - 06/11/2011 02:30 PM - ko1 (Koichi Sasada)
00000DoDoDoooondnononononooanoon

#7 - 07/14/2012 02:13 PM - matz (Yukihiro Matsumoto)

- Status changed from Assigned to Closed

Rubyl0000000NaNONaNOOOOODOO0DOODOODD
#8 - 07/14/2012 02:15 PM - ko1 (Koichi Sasada)
- Category set to doc
- Status changed from Closed to Assigned

- Assignee changed from matz (Yukihiro Matsumoto) to mrkn (Kenta Murata)

NaN [ NaN 000000000000000000000000
000000000000D00m_kn DOODODOODODD

#9 - 11/08/2012 10:18 AM - mrkn (Kenta Murata)

- Status changed from Assigned to Closed

#10 - 10/30/2017 08:58 PM - Eregon (Benoit Daloze)
Could someone summarize in English the rationale?
Float::NAN == Float::NAN # => false

The documentation says:

The result of NaN == NaN is undefined, so the implementation-dependent
value is returned.

But the result is false no matter the environment, isn't it? (NaN is the only numeric value never equal to itself)
And then we have:

[Float::NAN] == [Float::NAN] # => true
[0.0/0] == [Float::NAN] # => false

Which sounds to me like a bad side effect of short-circuiting in rb_equal on

if (a == D)
return Qtrue;
else
return rb_funcall(a, "==", 1, b);

#11 - 10/30/2017 10:59 PM - Eregon (Benoit Daloze)
At least IEEE 754 has NaN == NaN # => false.

#12 - 10/31/2017 03:07 AM - mame (Yusuke Endoh)

Summary:

ko1: [NaN] == [NaN] evaluates to true. This looks awkward since NaN == NaN is false and [1] == [1.0] is true.

matz: rb_equal first checks if the two sides are the same, which causes this behavior. NaN is a special object since equal? returns true but == returns
false. However, | don't want to make equivalence check slow for such a special case. There are some approaches to fix this issue: (1) make NaN ==
NaN, which is consistent but unnatural, (2) change rb_equal() not to check equal?, which will cause performance degradation, (3) change rb_equal()

to handle T_FLOAT specially, which will also cause performance degradation, and (4) do nothing. ... | decide that the comparison of NaN and NaN is

undefined in Ruby.

#13 - 10/31/2017 12:23 PM - Eregon (Benoit Daloze)

mame (Yusuke Endoh): Thank you for the summary, that's very helpful!

#14 - 11/01/2017 08:56 AM - Hanmac (Hans Mackowiak)

Eregon (Benoit Daloze)

checkout the object id Float::NAN.object_id != (0.0/0).object_id
while NAN is a constant, (0.0/0) returns a new object each time

thats why your Array compare shows a difference

02/22/2019

/4


https://redmine.ruby-lang.org/users/18
https://redmine.ruby-lang.org/users/772
http://www.tcpdf.org

